#declare generic = texture {pigment {rgb <.85, .44, .18>} finish {metallic ambient 0.3}}

#declare texture1 = texture {
  pigment { image_map {png "bespin1.png" map_type 2}}
  normal {bump_map {png "bespin1.png" map_type 2} bump_size 2}
  finish {metallic ambient 0.8}
}

#declare texture2 = texture {
  pigment {image_map {png "bespin2.png" map_type 2 }}
  normal {bump_map {png "bespin2.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture2b = texture {
  pigment {image_map {png "bespin2b.png" map_type 2 filter 0, 1}}
  finish {metallic ambient 0.8}
}

#declare texture3 = texture {
  pigment {image_map {png "bespin3.png" map_type 2}}
  normal {bump_map {png "bespin3.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture4 = texture {
  pigment {image_map {png "bespin4.png" map_type 2}}
  normal {bump_map {png "bespin4.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture4b = texture {
  pigment {image_map {png "bespin4b.png" map_type 2}}
  normal {bump_map {png "bespin4b.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture5 = texture {
  pigment {image_map {png "bespin5.png" map_type 2}}
  normal {bump_map {png "bespin5.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture5b = texture {
  pigment {image_map {png "bespin5b.png" map_type 2 }}
  normal {bump_map {png "bespin5b.png" map_type 2} bump_size 2}
  finish {ambient 0.2 diffuse 0.8 reflection 0.05 specular 0.75 roughness 0.15 metallic brilliance 2}
}

#declare texture5c = texture {
  pigment {image_map {png "bespin5c.png" map_type 2 filter 0,1}}
  finish {metallic ambient 0.8}
}

#declare texture6 = texture {
  pigment { image_map {png "bespin6.png" map_type 2}}
  normal {bump_map {png "bespin6.png" map_type 2} bump_size 2}
  finish {metallic ambient 0.8}
}

#declare unipod =
  sphere {0, 1  scale<100, 150, 100>
  texture{texture4b scale 100}
  translate y*-149
}

#declare stalk = cylinder{0, y*2300, 37.5 texture {texture4 scale 100} }

#declare repulsor = union{
  cone {0, 37.5, y*50, 75 }
  torus {65, 10 translate y*50}
  torus {80, 10 translate y*65}
  torus {95, 10 translate y*80}
  cone {0, 93, y*150, 250 translate y*90}
  cylinder {0, y*25, 265 translate y*230}
  cylinder {0, y*25, 300 translate y*255}
  cylinder {0, y*25, 335 translate y*290}
  texture {texture6 scale 300 translate y*11}
  translate y*2300
}

#declare vane = union
{
  cylinder {0, y*-50, 3}
  sphere {y*-50, 3}
  //pigment {rgb <0,1,1>}
  pigment {rgb 0}
}


#declare S1 = seed (1942)
#declare S2 = seed (12)
#declare S3 = seed (781234)


#declare bottom = union {
  cone {0, 300, y*260, 1525 texture {texture5 scale 275}}
  cylinder {0, y*15, 1525 translate y*260 texture {texture5b scale 25} texture {texture5c scale 25}}
  cylinder {0, y*50, 1450 translate y*275 texture {texture1 scale 50}}
  #declare vanes = 0
  #while (vanes < 100)
    #declare newX = (rand(S1)*1125)+350
    object {vane translate <newX, .185*newX-10, 0> rotate y*rand(S2)*360}
    #declare vanes = vanes + 1
  #end
  translate y*2615
  // Still need to add the weather sensor vanes
}

#declare mid = union {
  cone {0, 1575, y*25, 1600}
  cone {y*25, 1600, y*225, 1400}
  texture {texture2 scale 240 translate -y*20}
  texture {texture2b scale 240 translate -y*20}
  translate y*2940
}

#declare admins = union {
  cylinder {0, y*25, 1200 texture {texture1 scale 25}}
  cone {0, 1325, y*75, 1075 texture{texture3 scale 75} translate y*25}
  cylinder {0, y*25, 975 texture {texture1 scale 25} translate y*100}
  difference {
  cone {0, 1000, y*150, 450 texture{texture3 scale 50} translate y*125}
  cylinder {y*149.9, y*150.1, 451 texture{generic} translate y*125}
  }
  //cylinder {y*149.9, y*151, 460 pigment {rgb <1, 0, 0>} translate y*125}
  translate y*3190
}

#declare concourse = union{
  #declare Count = 0
  #while (Count < 500)
    #declare Type = rand(S1)
    #if (Type < .7)
      box {0, 1 scale <rand(S1)*25, rand(S2)*50, rand(S3)*25> translate x*rand(S1)*425 rotate y*rand(S2)*360}
    #else
      sphere {0, 1 scale rand(S2)*25 translate x*rand(S1)*425 rotate y*rand(S2)*360}
    #end
    #declare Count = Count +1
  #end
  texture{generic}
  translate y*3465
}

#declare CloudCity = union
{
  object{unipod}
  object{stalk}
  object{repulsor}
  object{bottom}
  object {mid}
  object {admins}
  object {concourse}
  scale .5
}
